package
{
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;

	public class Log
	{
		private static var _logView:ITextField;
		private static var formatFunction:Function = formatDefault;
				
		public static function initTextField(tf:TextField):void
		{
			_logView = ITextField(tf);
			formatFunction = formatHtml;
		}			
		
		private static function formatDefault(level:String, msg:String):String
		{
			return level + ": " + msg;
		}
		
		private static function formatHtml(level:String, msg:String):String
		{
			return "<b>" + level + "</b>: " + msg + "<br></br>";
		}
		
		public static function error(...args):void
		{
			for each(var msg:Object in args)
			{
				write("ERROR", String(msg));
			}
		}
		
		public static function warn(...args):void
		{
			for each(var msg:Object in args)
			{
				write("WARN", String(msg));
			}
		}
		
		public static function info(...args):void
		{
			for each(var msg:Object in args)
			{
				write("INFO", String(msg));
			}
		}
		
		public static function trace(...args):void
		{
			for each(var msg:Object in args)
			{
				write("DEBUG", String(msg));
			}
		}
		
		private static function write(level:String, msg:String):void
		{
			_logView.htmlText += formatFunction(level, msg);
			_logView.scrollV = _logView.maxScrollV;
		}
		
		public static function createDefaultTextField():TextField
		{
			var tf:TextField = new TextField2();
			tf.multiline = true;
			tf.autoSize = TextFieldAutoSize.LEFT;
			return tf;
		}
	}
}

interface ITextField
{
	function set htmlText(value:String):void;
	function get htmlText():String;
	
	function set scrollV(value:int):void;
	function get maxScrollV():int;
}

class TextField2 extends flash.text.TextField implements ITextField
{
	
}