package com.cuketa.test.profilerissue.main
{
	import com.cuketa.test.profilerissue.child.view.ChildSprite;
	import com.cuketa.test.profilerissue.main.controller.CommandCreateChildContext;
	import com.cuketa.test.profilerissue.main.controller.CommandFireSignalToChildContext;
	import com.cuketa.test.profilerissue.main.signals.SignalChildSpriteMediatorRegistered;
	import com.cuketa.test.profilerissue.main.signals.SignalDoStuffInChildContextRequested;
	import com.cuketa.test.profilerissue.main.view.MainViewMediator;
	
	import flash.display.DisplayObjectContainer;
	
	import org.robotlegs.base.ContextEvent;
	import org.robotlegs.core.IInjector;
	import org.robotlegs.mvcs.SignalContext;
	
	public final class MainContext extends SignalContext
	{
		public function MainContext(contextView:DisplayObjectContainer=null, autoStartup:Boolean=true)
		{
			Log.trace("MainContext.MainContext(contextView, autoStartup)");			
			
			super(contextView, autoStartup);
		}
		
		public override function startup():void
		{
			Log.trace("MainContext.startup()");
			
			commandMap.mapEvent(ContextEvent.STARTUP_COMPLETE, CommandCreateChildContext);
			
			injector.mapSingleton(SignalDoStuffInChildContextRequested);
			signalCommandMap.mapSignalClass(SignalChildSpriteMediatorRegistered, CommandFireSignalToChildContext);
						
			mediatorMap.mapView(ModularRobotlegsGCIssue, MainViewMediator);
			
			super.startup();
		}
	}
}