package com.cuketa.test.profilerissue.main.view
{
	import com.cuketa.test.profilerissue.main.events.ChildModuleCreatedEvent;
	
	import flash.display.DisplayObject;
	import flash.events.MouseEvent;
	
	import org.robotlegs.mvcs.Mediator;
	import org.robotlegs.utilities.modular.core.IModule;
	
	public final class MainViewMediator extends Mediator
	{
		[Inject] public var m_view:ModularRobotlegsGCIssue;

		private var childModule:IModule;
		
		public override function onRegister():void
		{
			Log.trace("MainViewMediator.onRegister()");
			
			addContextListener(ChildModuleCreatedEvent.CREATED, onChildModuleCreated, ChildModuleCreatedEvent);
			eventMap.mapListener(m_view._unloadButton, MouseEvent.CLICK, onClickedUnloadButton, MouseEvent);
		}
		
		private function onChildModuleCreated(e:ChildModuleCreatedEvent):void
		{
			Log.trace("MainViewMediator.onChildModuleCreated(e)");
			
			childModule = e._view;
			m_view.addChild(DisplayObject(childModule));
		}
		
		private function onClickedUnloadButton(e:MouseEvent):void
		{
			Log.trace("MainViewMediator.onClickedUnloadButton()");
			
			if(childModule)
			{
				m_view.removeChild(DisplayObject(childModule));
				
				childModule.dispose();
				childModule = null;	
			}
		}
	}
}